﻿// sem2_lab1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include "histogram.h"
#include "show_histogram.h"
#include "svg.h"
#include <curl/curl.h>
using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};
Input input_data(istream& in,bool prompt)
{
    Input in_data;
    int number_count;
    if(prompt)cerr << "Enter number count: ";
    in >> number_count;
    in_data.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        in >> in_data.numbers[i];
    }
    if (prompt)cerr << "Enter bin count: ";
    in >> in_data.bin_count;
    return in_data;
}
int main(int argc, char* argv[])
{
    if (argc > 1) 
    {
        CURL* curl = curl_easy_init();
        if (curl) 
        {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            if (res != CURLE_OK)
            {       
                    fprintf(stderr, "curl_easy_perform() failed: %s\n", curl_easy_strerror(res));
                    exit(1);
            }
         curl_easy_cleanup(curl);
         cout << res <<endl ;
        }
        return 0;
    }
    curl_global_init(CURL_GLOBAL_ALL);
    auto in = input_data(cin,true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins,in.numbers.size());
    return 0;
}


// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
